using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

// Add a reference to System.Numerics.
using System.Numerics;

namespace howto_use_biginteger
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCalculate_Click(object sender, EventArgs e)
        {
            long N;
            if (!long.TryParse(txtN.Text, out N))
            {
                MessageBox.Show("N must be an integer.");
                txtN.Focus();
                return;
            }

            checked
            {
                try
                {
                    txtLongFactorial.Text = LongFactorial(N).ToString();
                }
                catch (Exception ex)
                {
                    txtLongFactorial.Text = ex.Message;
                }
            }
            txtBigIntegerFactorial.Text = BigFactorial(N).ToString();
        }

        // Return N!.
        private BigInteger BigFactorial(BigInteger N)
        {
            if (N < 0) throw new ArgumentException("N must be at least 0.");
            if (N <= 1) return 1;
            BigInteger result = 1;
            for (int i = 2; i <= N; i++) result *= i;
            return result;
        }

        // Return N!.
        private long LongFactorial(long N)
        {
            if (N < 0) throw new ArgumentException("N must be at least 0.");
            if (N <= 1) return 1;
            checked
            {
                long result = 1;
                for (int i = 2; i <= N; i++) result *= i;
                return result;
            }
        }
    }
}
